
Option Strict On : Option Explicit On : Option Compare Binary : Option Infer On

Imports System
Imports System.Collections.ObjectModel
Imports System.Text.RegularExpressions


Namespace Code.Coloriser

    ''' <summary>
    ''' Defualt code coloriser for unknown languages
    ''' </summary>
    ''' <remarks>
    ''' known languages can derive from this although it is preferable they implement IColorTokenProvider directly.
    ''' </remarks>
    Friend Class UnknownCodeColoriser
        Inherits IColorTokenProvider

        Sub New()
            'Me.keywords = New String() {}
            'Me.m_stringOrCharRegexStr = ""
            'Me.m_commentRegexStr = ""
        End Sub


        Public Overrides ReadOnly Property CaseSensitive() As Boolean
            Get
                Return MyBase.CaseSensitive
            End Get
        End Property


        Protected Overrides ReadOnly Property CommentRegexStr() As String
            Get
                Return ""
            End Get
        End Property


        Protected Overrides ReadOnly Property StringOrCharRegexStr() As String
            Get
                Return ""
            End Get
        End Property


        Protected Overrides ReadOnly Property Keywords() As String
            Get
                Return ""
            End Get
        End Property


        Protected Overrides ReadOnly Property Preprocessors() As String
            Get
                Return MyBase.Preprocessors
            End Get
        End Property

    End Class

End Namespace
